diff --git a/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java b/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
index 516d5c72b..c5719e892 100644
--- a/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
@@ -1,219 +1,170 @@
 package net.minecraft.server.world.chunk.provider;
 
 import com.mojang.logging.LogUtils;
-import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
-import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
-import it.unimi.dsi.fastutil.ints.IntOpenHashSet;
-import it.unimi.dsi.fastutil.ints.IntSet;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.server.world.WorldServer;
 import net.minecraft.core.world.chunk.*;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.io.IOException;
 import java.util.*;
 
 public class ChunkProviderServer
-    implements IChunkProvider
-{
+    implements IChunkProvider {
     private static final Logger LOGGER = LogUtils.getLogger();
-    private final IntSet droppedChunksSet;
+    private final Set<ChunkPos> droppedChunksSet;
     private final Chunk emptyChunk;
     public ChunkGenerator chunkGenerator;
     private final IChunkLoader chunkLoader;
     public boolean chunkLoadOverride;
-    private final Int2ObjectMap<Chunk> chunkMap;
+    private final Map<ChunkPos, Chunk> chunkMap;
     private final List<Chunk> chunkList;
     private final WorldServer world;
 
-    public ChunkProviderServer(WorldServer world, IChunkLoader chunkLoader, ChunkGenerator chunkGenerator)
-    {
-        droppedChunksSet = new IntOpenHashSet();
-        chunkLoadOverride = false;
-        chunkMap = new Int2ObjectOpenHashMap<>();
-        chunkList = new ArrayList<>();
-        emptyChunk = new EmptyChunk(world, 0, 0);
+    public ChunkProviderServer(WorldServer world, IChunkLoader chunkLoader, ChunkGenerator chunkGenerator) {
+        this.droppedChunksSet = new HashSet<>();
+        this.chunkLoadOverride = false;
+        this.chunkMap = new HashMap<>();
+        this.chunkList = new ArrayList<>();
+        this.emptyChunk = new EmptyChunk(world, 0, 0);
         this.world = world;
         this.chunkLoader = chunkLoader;
         this.chunkGenerator = chunkGenerator;
     }
 
     @Override
-    public boolean isChunkLoaded(int chunkX, int chunkZ)
-    {
-        return chunkMap.containsKey(ChunkCoordinate.toInt(chunkX, chunkZ));
+    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
+        return this.chunkMap.containsKey(chunkPos);
     }
 
-    public void dropChunk(int chunkX, int chunkZ)
-    {
-        ChunkCoordinates spawnCoords = world.getSpawnPoint();
-        int spawnDistanceX = (chunkX * 16 + 8) - spawnCoords.x;
-        int spawnDistanceZ = (chunkZ * 16 + 8) - spawnCoords.z;
+    public void dropChunk(@NotNull ChunkPos chunkPos) {
+        ChunkCoordinates spawnCoords = this.world.getSpawnPoint();
+        int spawnDistanceX = (chunkPos.x * 16 + 8) - spawnCoords.x;
+        int spawnDistanceZ = (chunkPos.z * 16 + 8) - spawnCoords.z;
         int r = 128; // TODO replace spawn chunk values with a named constant
-        if(spawnDistanceX < -r || spawnDistanceX > r || spawnDistanceZ < -r || spawnDistanceZ > r) // Drop chunk if outside of spawn radius
+        if (spawnDistanceX < -r || spawnDistanceX > r || spawnDistanceZ < -r || spawnDistanceZ > r) // Drop chunk if outside of spawn radius
         {
-            droppedChunksSet.add(ChunkCoordinate.toInt(chunkX, chunkZ));
+            this.droppedChunksSet.add(new ChunkPos(chunkPos));
         }
     }
 
     @Override
-    public Chunk prepareChunk(int chunkX, int chunkZ)
-    {
-        int chunkRefId = ChunkCoordinate.toInt(chunkX, chunkZ);
-        droppedChunksSet.remove(chunkRefId);
-        Chunk chunk = chunkMap.get(chunkRefId);
-        if(chunk == null)
-        {
-            chunk = loadChunkFromFile(chunkX, chunkZ);
-            if(chunk == null)
-            {
-                if (chunkGenerator != null)
-                {
-                    chunk = chunkGenerator.generate(chunkX, chunkZ);
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        this.droppedChunksSet.remove(chunkPos);
+        Chunk chunk = this.chunkMap.get(chunkPos);
+        if (chunk == null) {
+            chunk = loadChunkFromFile(chunkPos);
+            if (chunk == null) {
+                if (this.chunkGenerator != null) {
+                    chunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
                     chunk.fixMissingBlocks();
-                }
-                else
-                {
-                    chunk = emptyChunk;
+                } else {
+                    chunk = this.emptyChunk;
                 }
             }
-            chunkMap.put(chunkRefId, chunk);
-            chunkList.add(chunk);
-            if(chunk != null)
-            {
-                chunk.onLoad();
+            this.chunkMap.put(new ChunkPos(chunkPos), chunk);
+            this.chunkList.add(chunk);
+            chunk.checkForLightGaps();
+            chunk.onLoad();
+            if (!chunk.isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
+                populate(this, chunkPos.x, chunkPos.z);
             }
-            if(!chunk.isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX + 1, chunkZ))
-            {
-                populate(this, chunkX, chunkZ);
+            if (isChunkLoaded(chunkPos.x - 1, chunkPos.z) && !provideChunk(chunkPos.x - 1, chunkPos.z).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
+                populate(this, chunkPos.x - 1, chunkPos.z);
             }
-            if(isChunkLoaded(chunkX - 1, chunkZ) && !provideChunk(chunkX - 1, chunkZ).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX - 1, chunkZ))
-            {
-                populate(this, chunkX - 1, chunkZ);
+            if (isChunkLoaded(chunkPos.x, chunkPos.z - 1) && !provideChunk(chunkPos.x, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
+                populate(this, chunkPos.x, chunkPos.z - 1);
             }
-            if(isChunkLoaded(chunkX, chunkZ - 1) && !provideChunk(chunkX, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX + 1, chunkZ))
-            {
-                populate(this, chunkX, chunkZ - 1);
+            if (isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && !provideChunk(chunkPos.x - 1, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
+                populate(this, chunkPos.x - 1, chunkPos.z - 1);
             }
-            if(isChunkLoaded(chunkX - 1, chunkZ - 1) && !provideChunk(chunkX - 1, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX - 1, chunkZ))
-            {
-                populate(this, chunkX - 1, chunkZ - 1);
-            }
-            if (world.getCurrentWeather() != null)
-            {
-                world.getCurrentWeather().doChunkLoadEffect(world, chunk);
+            if (this.world.getCurrentWeather() != null) {
+                this.world.getCurrentWeather().doChunkLoadEffect(this.world, chunk);
             }
         }
         return chunk;
     }
 
     @Override
-    public void regenerateChunk(int chunkX, int chunkZ)
-    {
-        int chunkRefId = ChunkCoordinate.toInt(chunkX, chunkZ);
-        droppedChunksSet.remove(chunkRefId);
-        chunkList.remove(chunkMap.get(chunkRefId));
-        chunkMap.remove(chunkRefId);
+    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
+        this.droppedChunksSet.remove(chunkPos);
+        this.chunkList.remove(this.chunkMap.get(chunkPos));
+        this.chunkMap.remove(chunkPos);
         Chunk chunk;
-        if (chunkGenerator != null)
-        {
-            chunk = chunkGenerator.generate(chunkX, chunkZ);
+        if (this.chunkGenerator != null) {
+            chunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
             chunk.fixMissingBlocks();
-        }
-        else
-        {
+        } else {
             return;
         }
-        chunkMap.put(chunkRefId, chunk);
-        if(!chunk.isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX + 1, chunkZ))
-        {
-            populate(this, chunkX, chunkZ);
+        this.chunkMap.put(new ChunkPos(chunkPos), chunk);
+        if (!chunk.isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
+            populate(new ChunkPos(chunkPos.x, chunkPos.z));
         }
-        if(isChunkLoaded(chunkX - 1, chunkZ) && !provideChunk(chunkX - 1, chunkZ).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX - 1, chunkZ))
-        {
-            populate(this, chunkX - 1, chunkZ);
+        if (isChunkLoaded(chunkPos.x - 1, chunkPos.z) && !provideChunk(chunkPos.x - 1, chunkPos.z).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
+            populate(new ChunkPos(chunkPos.x - 1, chunkPos.z));
         }
-        if(isChunkLoaded(chunkX, chunkZ - 1) && !provideChunk(chunkX, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX + 1, chunkZ))
-        {
-            populate(this, chunkX, chunkZ - 1);
+        if (isChunkLoaded(chunkPos.x, chunkPos.z - 1) && !provideChunk(chunkPos.x, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
+            populate(new ChunkPos(chunkPos.x, chunkPos.z - 1));
         }
-        if(isChunkLoaded(chunkX - 1, chunkZ - 1) && !provideChunk(chunkX - 1, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX - 1, chunkZ))
-        {
-            populate(this, chunkX - 1, chunkZ - 1);
+        if (isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && !provideChunk(chunkPos.x - 1, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
+            populate(new ChunkPos(chunkPos.x - 1, chunkPos.z - 1));
         }
     }
 
     @Override
-    public Chunk provideChunk(int chunkX, int chunkZ)
-    {
-        Chunk chunk = chunkMap.get(ChunkCoordinate.toInt(chunkX, chunkZ));
-        if(chunk == null)
-        {
-            if(world.findingSpawnPoint || chunkLoadOverride)
-            {
-                return prepareChunk(chunkX, chunkZ);
+    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        Chunk chunk = this.chunkMap.get(chunkPos);
+        if (chunk == null) {
+            if (this.world.findingSpawnPoint || this.chunkLoadOverride) {
+                return prepareChunk(chunkPos, true);
+            } else {
+                return this.emptyChunk;
             }
-            else
-            {
-                return emptyChunk;
-            }
-        }
-        else
-        {
+        } else {
             return chunk;
         }
     }
 
-    private Chunk loadChunkFromFile(int chunkX, int chunkZ)
-    {
-        if (chunkLoader == null)
-        {
+    private Chunk loadChunkFromFile(@NotNull ChunkPos chunkPos) {
+        if (this.chunkLoader == null) {
             return null;
         }
-        try
-        {
-            Chunk chunk = chunkLoader.loadChunk(world, chunkX, chunkZ);
-            if (chunk != null)
-            {
-                chunk.lastSaveTime = world.getWorldTime();
+        try {
+            Chunk chunk = this.chunkLoader.loadChunk(this.world, chunkPos.x, chunkPos.z);
+            if (chunk != null) {
+                chunk.lastSaveTime = this.world.getWorldTime();
             }
             return chunk;
-        }
-        catch (Exception exception)
-        {
-            LOGGER.error("Failed to load chunk at X:{}, Z:{} to disk!", chunkX, chunkZ, exception);
+        } catch (Exception exception) {
+            LOGGER.error("Failed to load chunk at X:{}, Z:{} to disk!", chunkPos.x, chunkPos.z, exception);
         }
         return null;
     }
 
-    private void saveChunkToFile(Chunk chunk)
-    {
-        if (chunkLoader == null)
-        {
+    private void saveChunkToFile(Chunk chunk) {
+        if (this.chunkLoader == null) {
             return;
         }
-        try
-        {
-            chunk.lastSaveTime = world.getWorldTime();
-            chunkLoader.saveChunk(world, chunk);
-        }
-        catch (IOException ioexception)
-        {
+        try {
+            chunk.lastSaveTime = this.world.getWorldTime();
+            this.chunkLoader.saveChunk(this.world, chunk);
+        } catch (IOException ioexception) {
             LOGGER.error("Failed to save chunk at X:{}, Z:{} to disk!", chunk.pos.x, chunk.pos.z, ioexception);
         }
     }
 
     @Override
-    public void populate(IChunkProvider chunkProvider, int chunkX, int chunkZ)
-    {
-        Chunk chunk = provideChunk(chunkX, chunkZ);
-        if (!chunk.isTerrainPopulated)
-        {
+    public void populate(@NotNull ChunkPos chunkPos) {
+        Chunk chunk = provideChunk(chunkPos, true);
+        if (!chunk.isTerrainPopulated) {
             chunk.isTerrainPopulated = true;
-            if (this.chunkGenerator != null)
-            {
+            if (this.chunkGenerator != null) {
                 this.chunkGenerator.decorate(chunk);
                 chunk.setChunkModified();
             }
@@ -221,20 +172,16 @@ public class ChunkProviderServer
     }
 
     @Override
-    public boolean saveChunks(boolean saveImmediately, ProgressListener progressUpdate)
-    {
-        saveImmediately |= world.mcServer.forceSaveAllChunksOnAutosave;
+    public boolean saveChunks(boolean saveImmediately, @Nullable ProgressListener progressListener) {
+        saveImmediately |= this.world.mcServer.forceSaveAllChunksOnAutosave;
         int chunksSaved = 0;
-        for (Chunk chunk : chunkList)
-        {
-            if (!chunk.needsSaving(saveImmediately))
-            {
+        for (Chunk chunk : this.chunkList) {
+            if (!chunk.needsSaving(saveImmediately)) {
                 continue;
             }
             saveChunkToFile(chunk);
             chunk.isModified = false;
-            if (++chunksSaved == world.mcServer.chunksSavedPerAutosave && !saveImmediately)
-            {
+            if (++chunksSaved == this.world.mcServer.chunksSavedPerAutosave && !saveImmediately) {
                 return false;
             }
         }
@@ -243,51 +190,44 @@ public class ChunkProviderServer
     }
 
     @Override
-    public boolean tick()
-    {
-        if(!world.dontSave)
-        {
-            for(int i = 0; i < 100; i++)
-            {
-                if(!droppedChunksSet.isEmpty())
-                {
-                    int integer = droppedChunksSet.iterator().nextInt();
-                    Chunk chunk = chunkMap.get(integer);
+    public boolean tick() {
+        if (!this.world.dontSave) {
+            for (int i = 0; i < 100; i++) {
+                if (!this.droppedChunksSet.isEmpty()) {
+                    ChunkPos chunkPos = this.droppedChunksSet.iterator().next();
+                    Chunk chunk = this.chunkMap.get(chunkPos);
                     saveChunkToFile(chunk);
                     chunk.onUnload();
-                    droppedChunksSet.remove(integer);
-                    chunkMap.remove(integer);
-                    chunkList.remove(chunk);
+                    this.droppedChunksSet.remove(chunkPos);
+                    this.chunkMap.remove(chunkPos);
+                    this.chunkList.remove(chunk);
                 }
             }
         }
         return false;
     }
-    
+
     @Override
-    public void unloadAllChunks()
-    {
-    	chunkMap.clear();
-    	chunkList.clear();
-    	droppedChunksSet.clear();
-        chunkGenerator = null;
-    	System.gc();
+    public void unloadAllChunks() {
+        this.chunkMap.clear();
+        this.chunkList.clear();
+        this.droppedChunksSet.clear();
+        this.chunkGenerator = null;
+        System.gc();
     }
 
     @Override
-    public boolean canSave()
-    {
-        return !world.dontSave;
+    public boolean canSave() {
+        return !this.world.dontSave;
     }
-    
+
     @Override
-    public String getInfoString()
-    {
-    	return "";
+    public @NotNull String getInfoString() {
+        return "";
     }
 
     @Override
-    public void setCurrentChunkOver(int chunkX, int chunkZ) {
+    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
         // Do nothing
     }
 }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
index dad2553b0..a1b724d2f 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
@@ -1,19 +1,18 @@
 package org.useless.seedviewer;
 
 import net.minecraft.core.util.collection.NamespaceID;
-import org.useless.seedviewer.collections.ChunkLocation;
-import org.useless.seedviewer.collections.ChunkPos2D;
-import org.useless.seedviewer.collections.ChunkPos3D;
+import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkTilePos;
 import org.useless.seedviewer.data.ViewerBiome;
 import org.useless.seedviewer.data.ViewerChunk;
 import org.useless.seedviewer.gui.ChunkProvider;
 
 public class TestChunkProvider implements ChunkProvider {
     @Override
-    public ViewerChunk getChunk(ChunkLocation location) {
+    public ViewerChunk getChunk(ChunkPos location) {
         return new ViewerChunk() {
             @Override
-            public ViewerBiome getBiome(ChunkPos3D pos) {
+            public ViewerBiome getBiome(ChunkTilePos pos) {
                 return new ViewerBiome() {
                     @Override
                     public String getName() {
@@ -36,17 +35,17 @@ public class TestChunkProvider implements ChunkProvider {
             }
 
             @Override
-            public int getBlockColor(ChunkPos3D pos) {
+            public int getBlockColor(ChunkTilePos pos) {
                 return 0;
             }
 
             @Override
-            public int getHeight(ChunkPos2D pos) {
+            public int getHeight(ChunkTilePos pos) {
                 return 128;
             }
 
             @Override
-            public int getWaterDepth(ChunkPos2D pos) {
+            public int getWaterDepth(ChunkTilePos pos) {
                 return 0;
             }
         };
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
index a53b39378..cb9b399df 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
@@ -13,14 +13,14 @@ public class BTABiome implements ViewerBiome {
     }
     @Override
     public String getName() {
-        if (biome == null) return "Unknown";
-        return I18n.getInstance().translateKey(biome.translationKey);
+        if (this.biome == null) return "Unknown";
+        return I18n.getInstance().translateKey(this.biome.translationKey);
     }
 
     @Override
     public NamespaceID getID() {
         try {
-            return NamespaceID.fromPool(Registries.BIOMES.getKey(biome)).copyUnpooled();
+            return NamespaceID.fromPool(Registries.BIOMES.getKey(this.biome)).copyUnpooled();
         } catch (HardIllegalArgumentException e) {
             throw new IllegalArgumentException(e);
         }
@@ -28,7 +28,7 @@ public class BTABiome implements ViewerBiome {
 
     @Override
     public int getColor() {
-        if (biome == null) return 0x00000000;
-        return biome.color;
+        if (this.biome == null) return 0x00000000;
+        return this.biome.color;
     }
 }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
index f6996d8e8..50f0fbfca 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
@@ -9,10 +9,10 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
+import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.type.WorldTypes;
 import org.useless.seedviewer.bta.worldloader.ChunkLoader;
-import org.useless.seedviewer.collections.ChunkLocation;
 import org.useless.seedviewer.data.ViewerChunk;
 import org.useless.seedviewer.gui.ChunkProvider;
 import org.slf4j.Logger;
@@ -40,26 +40,26 @@ public class BTAChunkProvider implements ChunkProvider {
 
 
     public BTAChunkProvider(long seed) {
-        biomeProvider = new BiomeProviderOverworld(seed, WorldTypes.OVERWORLD_EXTENDED);
+        this.biomeProvider = new BiomeProviderOverworld(seed, WorldTypes.OVERWORLD_EXTENDED);
     }
 
     public BTAChunkProvider(File worldFolder, LevelData data) {
-        biomeProvider = new BiomeProviderOverworld(data.getRandomSeed(), WorldTypes.OVERWORLD_EXTENDED);
-        chunkLoader = new ChunkLoader(worldFolder, 0);
+        this.biomeProvider = new BiomeProviderOverworld(data.getRandomSeed(), WorldTypes.OVERWORLD_EXTENDED);
+        this.chunkLoader = new ChunkLoader(worldFolder, 0);
     }
     @Override
-    public ViewerChunk getChunk(ChunkLocation location) {
-        if (chunkLoader != null) {
+    public ViewerChunk getChunk(ChunkPos location) {
+        if (this.chunkLoader != null) {
             try {
-                net.minecraft.core.world.chunk.Chunk c = chunkLoader.loadChunk(location);
+                net.minecraft.core.world.chunk.Chunk c = this.chunkLoader.loadChunk(location);
                 if (c != null) {
-                    return new BTAComplexChunk(c, biomeProvider);
+                    return new BTAComplexChunk(c, this.biomeProvider);
                 }
             } catch (IOException e) {
                 LOGGER.error("Failed to load chunk data for chunk {}, {}", location.x, location.z, e);
             }
         }
-        return new BTASimpleChunk(location, biomeProvider);
+        return new BTASimpleChunk(location, this.biomeProvider);
     }
 
 }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
index 5302ec8d9..cde883a99 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
@@ -5,9 +5,8 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.MaterialColor;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.pos.ChunkTilePos;
 import org.jetbrains.annotations.NotNull;
-import org.useless.seedviewer.collections.ChunkPos2D;
-import org.useless.seedviewer.collections.ChunkPos3D;
 import org.useless.seedviewer.data.ViewerBiome;
 import org.useless.seedviewer.data.ViewerChunk;
 
@@ -19,33 +18,33 @@ public class BTAComplexChunk implements ViewerChunk {
         this.provider = biomeProvider;
     }
     @Override
-    public ViewerBiome getBiome(ChunkPos3D pos) {
-        net.minecraft.core.world.biome.Biome b = chunk.getBlockBiome(pos.x, pos.y, pos.z);
-        if (b != null) return new BTABiome(b);;
-        return new BTABiome(provider.getBiome(chunk.pos.x * ViewerChunk.CHUNK_SIZE_X + pos.x, pos.y, chunk.pos.z * ViewerChunk.CHUNK_SIZE_Z + pos.z));
+    public ViewerBiome getBiome(ChunkTilePos pos) {
+        net.minecraft.core.world.biome.Biome b = this.chunk.getBlockBiome(pos);
+        if (b != null) return new BTABiome(b);
+        return new BTABiome(this.provider.getBiome(this.chunk.pos.x * ViewerChunk.CHUNK_SIZE_X + pos.x, pos.y, this.chunk.pos.z * ViewerChunk.CHUNK_SIZE_Z + pos.z));
     }
 
     @Override
-    public int getBlockColor(ChunkPos3D pos) {
-        Block<?> b = Blocks.getBlock(chunk.getBlockID(pos.x, pos.y, pos.z));
+    public int getBlockColor(ChunkTilePos pos) {
+        Block<?> b = Blocks.getBlock(this.chunk.getBlockId(pos));
         if (b == null) return 0;
-        int meta = chunk.getBlockMetadata(pos.x, pos.y, pos.z);
+        int meta = this.chunk.getBlockData(pos);
         return MaterialColor.getColorFromIndex(MaterialColor.getColorIndexFromBlock(b, meta)) | 0xFF_00_00_00;
     }
 
     @Override
-    public int getHeight(ChunkPos2D pos) {
-        return chunk.getHeightValue(pos.x, pos.z);
+    public int getHeight(ChunkTilePos pos) {
+        return this.chunk.getHeightValue(pos.x, pos.z);
     }
 
     @Override
-    public int getWaterDepth(ChunkPos2D pos) {
+    public int getWaterDepth(ChunkTilePos pos) {
         int start = getHeight(pos) - 1;
         int depth = 0;
         while (true) {
             int y = start - depth;
             if (y < 0) break;
-            Block<?> b = Blocks.getBlock(chunk.getBlockID(pos.x, y, pos.z));
+            Block<?> b = Blocks.getBlock(this.chunk.getBlockId(new ChunkTilePos(pos.x, y, pos.z)));
             if (b == null) break;
             if (b.getMaterial() != Material.water) break;
             depth++;
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTASimpleChunk.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTASimpleChunk.java
index 1951905be..b109733f2 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTASimpleChunk.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTASimpleChunk.java
@@ -1,36 +1,35 @@
 package org.useless.seedviewer.bta;
 
 import net.minecraft.core.world.biome.provider.BiomeProvider;
-import org.useless.seedviewer.collections.ChunkLocation;
-import org.useless.seedviewer.collections.ChunkPos2D;
-import org.useless.seedviewer.collections.ChunkPos3D;
+import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkTilePos;
 import org.useless.seedviewer.data.ViewerBiome;
 import org.useless.seedviewer.data.ViewerChunk;
 
 public class BTASimpleChunk implements ViewerChunk {
-    private final ChunkLocation location;
+    private final ChunkPos location;
     private final BiomeProvider provider;
-    public BTASimpleChunk(ChunkLocation location, BiomeProvider biomeProvider) {
+    public BTASimpleChunk(ChunkPos location, BiomeProvider biomeProvider) {
         this.location = location;
-        provider = biomeProvider;
+        this.provider = biomeProvider;
     }
     @Override
-    public ViewerBiome getBiome(ChunkPos3D pos) {
-        return new BTABiome(provider.getBiome(location.x * ViewerChunk.CHUNK_SIZE_X + pos.x, pos.y, location.z * ViewerChunk.CHUNK_SIZE_Z + pos.z));
+    public ViewerBiome getBiome(ChunkTilePos pos) {
+        return new BTABiome(this.provider.getBiome(this.location.x * ViewerChunk.CHUNK_SIZE_X + pos.x, pos.y, this.location.z * ViewerChunk.CHUNK_SIZE_Z + pos.z));
     }
 
     @Override
-    public int getBlockColor(ChunkPos3D pos) {
+    public int getBlockColor(ChunkTilePos pos) {
         return 0;
     }
 
     @Override
-    public int getHeight(ChunkPos2D pos) {
+    public int getHeight(ChunkTilePos pos) {
         return 128;
     }
 
     @Override
-    public int getWaterDepth(ChunkPos2D pos) {
+    public int getWaterDepth(ChunkTilePos pos) {
         return 0;
     }
 }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAWorld.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAWorld.java
index f404bcfed..c12cff37d 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAWorld.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAWorld.java
@@ -18,26 +18,26 @@ public class BTAWorld implements ViewerWorld {
     }
     @Override
     public File getFolder() {
-        return worldFolder;
+        return this.worldFolder;
     }
 
     @Override
     public long getSeed() {
-        return data.getRandomSeed();
+        return this.data.getRandomSeed();
     }
 
     @Override
     public String getName() {
-        return data.getWorldName();
+        return this.data.getWorldName();
     }
 
     @Override
     public long getLastPlayed() {
-        return data.getLastTimePlayed();
+        return this.data.getLastTimePlayed();
     }
 
     @Override
     public ChunkProvider getChunkProvider() {
-        return new BTAChunkProvider(worldFolder, data);
+        return new BTAChunkProvider(this.worldFolder, this.data);
     }
 }
